<!-- 选择开箱记录 -->
<script lang="ts" setup name="SelectUnpackRecordDialog">
import { ElMessage } from 'element-plus'
import type { Ref } from 'vue'
import { ref } from 'vue'
import dayjs from 'dayjs'
import type { DateModelType } from 'element-plus'
import { SCHEDULE } from '@/utils/scheduleDict'
import { getResumeUnpackList } from '@/api/equipment/resume/unpack'
import type { TableColumn } from '@/components/NormalTable/table_interface'
const emits = defineEmits(['confirm'])
const dialogFormVisible = ref(false)
// 查询条件
const listQuery = ref({
  approvalStatus: '0', // 审批状态类型-全部
  createUserName: '', // 验收人
  equipmentName: '', // 设备名称
  formId: SCHEDULE.UNPACKING_INSPECTING_APPROVAL, // 表单id
  logNo: '', // 记录表编号
  receiveTimeEnd: '', // 验收日期结束
  receiveTimeStart: '', // 验收日期开始
  limit: 20,
  offset: 1,
})
// 多选选中的内容
const checkoutList = ref([])
const loadingTable = ref(false)
const list = ref([]) // 表格数据
const dateRange = ref<[DateModelType, DateModelType]>(['', ''])// 筛选时间段数据
const total = ref(0)
const columns = ref<TableColumn[]>([
  { text: '记录表编号', value: 'logNo', align: 'center', width: '160' },
  { text: '记录表名称', value: 'logName', align: 'center' },
  { text: '设备名称', value: 'equipmentName', align: 'center' },
  { text: '型号', value: 'model', align: 'center' },
  { text: '生产厂家', value: 'manufacturer', align: 'center' },
  { text: '到货时间', value: 'arrivalTime', align: 'center', width: '180' },
  { text: '验收人', value: 'createUserName', align: 'center' },
  { text: '验收时间', value: 'receiveTime', align: 'center', width: '180' },
])

// 数据查询
function fetchData(isNowPage = false) {
  loadingTable.value = true
  if (!isNowPage) {
    // 是否显示当前页，否则跳转第一页
    listQuery.value.offset = 1
  }
  getResumeUnpackList(listQuery.value).then((response) => {
    list.value = response.data.rows
    total.value = parseInt(response.data.total)
    loadingTable.value = false
  })
}
// 重置
const clearList = () => {
  listQuery.value = {
    approvalStatus: '0', // 审批状态类型-全部
    createUserName: '', // 验收人
    equipmentName: '', // 设备名称
    formId: SCHEDULE.UNPACKING_INSPECTING_APPROVAL, // 表单id
    logNo: '', // 记录表编号
    receiveTimeEnd: '', // 验收日期结束
    receiveTimeStart: '', // 验收日期开始
    limit: 20,
    offset: 1,
  }
  dateRange.value = ['', '']
  fetchData()
}
// 搜索
const search = () => {
  fetchData(true)
}
// 多选选中
const handleSelectionChange = (val: any) => {
  checkoutList.value = val
}
// 页数发生变化后的操作，可能是页码变化，可能是每页容量变化，此函数必写
const changePage = (val: { size?: number;page?: number }) => {
  if (val && val.size) {
    listQuery.value.limit = val.size
  }
  if (val && val.page) {
    listQuery.value.offset = val.page
  }
  search()
}
// 点击确定
const confirmSelect = () => {
  if (!checkoutList.value.length) {
    ElMessage.warning('请选择开箱记录')
  }
  else {
    emits('confirm', checkoutList.value)
    dialogFormVisible.value = false
  }
}
// 取消
const resetForm = () => {
  dialogFormVisible.value = false
  clearList()
}
// 初始化
const initDialog = () => {
  dialogFormVisible.value = true
  fetchData()
}
defineExpose({ initDialog })

watch(dateRange, (val) => {
  if (val) {
    listQuery.value.receiveTimeStart = `${val[0]}`
    listQuery.value.receiveTimeEnd = `${val[1]}`
  }
  else {
    listQuery.value.receiveTimeStart = ''
    listQuery.value.receiveTimeEnd = ''
  }
})
</script>

<template>
  <el-dialog v-if="dialogFormVisible" v-model="dialogFormVisible" title="选择开箱记录" width="65%">
    <search-area :need-clear="true" @search="search" @clear="clearList">
      <search-item>
        <el-input v-model.trim="listQuery.logNo" placeholder="记录表编号" class="short-input" clearable />
      </search-item>
      <search-item>
        <el-input v-model.trim="listQuery.equipmentName" placeholder="设备名称" class="short-input" clearable />
      </search-item>
      <search-item>
        <el-input v-model.trim="listQuery.createUserName" placeholder="验收人" class="short-input" clearable />
      </search-item>
      <search-item>
        <el-date-picker
          v-model="dateRange"
          class="short-input"
          type="daterange"
          range-separator="至"
          format="YYYY-MM-DD"
          value-format="YYYY-MM-DD"
          start-placeholder="创建日期(开始)"
          end-placeholder="创建日期(结束)"
        />
      </search-item>
    </search-area>

    <!-- 查询结果Table显示 -->
    <div style="padding: 12px;">
      <normal-table
        :data="list"
        :total="total"
        :columns="columns"
        :query="listQuery"
        is-showmulti-select
        :list-loading="loadingTable"
        :is-multi="false"
        :height="260"
        :page-sizes="[20]"
        @change="changePage"
        @multi-select="handleSelectionChange"
      >
        <!-- 序号 -->
        <template #preColumns>
          <el-table-column label="#" width="55" align="center" fixed>
            <template #default="scope">
              {{ (listQuery.offset - 1) * listQuery.limit + scope.$index + 1 }}
            </template>
          </el-table-column>
        </template>
      </normal-table>
    </div>
    <template #footer>
      <span class="dialog-footer">
        <el-button type="primary" @click="confirmSelect">确认</el-button>
        <el-button @click="resetForm">
          取消
        </el-button>
      </span>
    </template>
  </el-dialog>
</template>

<style lang="scss" scoped>
:deep(.el-radio__label) {
  display: none;
}
</style>
